program politicheskaya_karta;
{$APPTYPE CONSOLE}

const
  maxq = 1000100;
  maxn = 1010;

type
  pt = record
    i, j: integer;
  end;

var
  i, j, w, h, lb, ub, ic, jc, res, di, dj: integer;
  painted: array[0..maxn, 0..maxn] of boolean;
  m: array[0..maxn, 0..maxn] of integer;
  queue: array[0..maxq] of pt;

begin
  assignfile(input, 'input.txt'); reset(input);
  assignfile(output, 'output.txt'); rewrite(output);

  read (w, h);
  for i := 1 to h do
    for j := 1 to w do read (m[i, j]);


  for i := 1 to h do
    for j := 1 to w do 
      if not painted[i, j] then
      begin
        inc(res);
        lb := 0; ub := 1;
        queue[1].i := i; queue[1].j := j;
        painted[i, j] := true;

        while lb <> ub do
        begin
          lb := (lb + 1) mod maxq;
          ic := queue[lb].i; jc := queue[lb].j;

          for di := -1 to 1 do
            for dj := -1 to 1 do
              if ((di = 0) xor (dj = 0)) and 
                 (ic + di > 0) and (ic + di <= h) and (jc + dj > 0) and (jc + dj <= w) and 
                 (not painted[ic + di, jc + dj]) and (m[ic + di, jc + dj] = m[i, j]) then
              begin
                ub := (ub + 1) mod maxq;
                queue[ub].i := ic + di; queue[ub].j := jc + dj;
                painted[ic + di, jc + dj] := true;
              end;
        end;
      end;

  write(res);
  closefile(input); closefile(output);
end.